Loading...
Searching...
No Matches
BALL::CIFFile Class Reference
Molecular Modeling » File Formats » Molecular structure file formats

`#include <BALL/FORMAT/CIFFile.h>`

Inheritance diagram for BALL::CIFFile:

## Classes

class | Item
class | SaveFrame
class | Datacontent
class | Datablock
struct | State

## Public Member Functions

Constructors and Destructors
| CIFFile ()
| CIFFile (const String &filename, File::OpenMode open_mode=std::ios::in)
virtual | ~CIFFile ()
Reading and Writing of Crytallographic Information
virtual bool | write ()
virtual bool | read ()
Public Member Functions inherited from BALL::File
| File ()
| File (const String &name, OpenMode open_mode=std::ios::in)
virtual | ~File ()
virtual void | clear ()
bool | isValid () const
bool | open (const String &name, File::OpenMode open_mode=std::ios::in)
bool | reopen ()
bool | reopen (File::OpenMode open_mode)
void | close ()
const String & | getName () const
void | setName (const String &name)
const String & | getOriginalName () const
Size | getSize ()
File::OpenMode | getOpenMode () const
Type | getType (bool trace_link) const
bool | copyTo (const String &destination_name, Size buffer_size=4096)
bool | moveTo (const String &destination_name)
bool | remove ()
bool | renameTo (const String &new_path)
bool | truncate (Size size=0)
std::fstream & | getFileStream ()
TransformationManager & | getTransformationManager ()
const TransformationManager & | getTransformationManager () const
bool | operator== (const File &file) const
bool | operator!= (const File &file) const
bool | isOpen () const
bool | isClosed () const
bool | isAccessible () const
bool | isCanonized () const
bool | isReadable () const
bool | isWritable () const
bool | isExecutable () const

## Accessors

static State | state
Molecule * | molecule_
String | current_datablock_
String | current_saveframe_
String | current_item_
StringHashMap< Index > | datablocks_hash_
vector< Datablock > | datablocks_
void | inSafeframe (const char *name)
void | inItem (const char *name)
void | inDatablock (const char *name)
void | insertDatablock (const Datablock &datablock)
const Datablock & | getDatablock (const String &name) const
Datablock & | getDatablock (const String &name)
bool | hasDatablock (const String &name) const
void | setMolecule (Molecule *molecule)
void | clearParameters ()
virtual void | initRead_ ()

## Additional Inherited Members

Public Types inherited from BALL::File
typedef std::ios::openmode | OpenMode
enum | Transformation { TRANSFORMATION__EXEC = 1 , TRANSFORMATION__FILTER = 2 , TRANSFORMATION__URL = 3 }
enum | Type { TYPE__UNKNOWN = 0 , TYPE__DIRECTORY = 1 , TYPE__CHAR_SPECIAL_FILE = 2 , TYPE__BLOCK_SPECIAL_FILE = 3 , TYPE__REGULAR_FILE = 4 , TYPE__SYMBOLIC_LINK = 5 , TYPE__SOCKET = 6 , TYPE__FIFO_SPECIAL_FILE = 7 }
static Size | getSize (String name)
static Type | getType (String name, bool trace_link)
static bool | copy (String source_name, String destination_name, Size buffer_size=4096)
static bool | move (const String &source_name, const String &destination_name)
static bool | remove (String name)
static bool | rename (String old_path, String new_path)
static bool | truncate (String path, Size size=0)
static bool | createTemporaryFilename (String &temporary, const String &suffix=".TMP")
static void | enableTransformation (Transformation transformation)
static void | disableTransformation (Transformation transformation)
static bool | isTransformationEnabled (Transformation transformation)
static void | registerTransformation (const String &pattern, const String &exec)
static void | unregisterTransformation (const String &pattern)
static bool | isAccessible (String name)
static bool | isReadable (String name)
static bool | isWritable (String name)
static bool | isExecutable (String name)
Static Public Attributes inherited from BALL::File
static const OpenMode | MODE_IN
| Open for input (default).
static const OpenMode | MODE_OUT
| Open for output.
static const OpenMode | MODE_APP
| Append. Seek to end before each write operation.
static const OpenMode | MODE_BINARY
| Binary mode.
static const OpenMode | MODE_ATE
| Seek to end directly after opening.
static const OpenMode | MODE_TRUNC
| Truncate an existing file.
static const String | TRANSFORMATION_EXEC_PREFIX
| Prefix for filenames that are created through the execution of commands "exec:".
static const String | TRANSFORMATION_FILE_PREFIX
| Prefix for files (to mimick URL-like behavior) "file:".
static const String | TRANSFORMATION_FTP_PREFIX
| Prefix for FTP-transfers "ftp://".
static const String | TRANSFORMATION_HTTP_PREFIX
| Prefix for HTTP-transfer "http://".
String | name_
String | original_name_
OpenMode | open_mode_
bool | is_open_
bool | is_temporary_
static HashSet< String > | created_temp_filenames_
static TransformationManager | transformation_manager_
static Size | transformation_methods_

## Detailed Description

CIF file class. This class enables BALL to read and write input and output CIF files for the NMR shift application.

Definition at line 32 of file CIFFile.h.

## Constructor & Destructor Documentation

## CIFFile() [1/2]

BALL::CIFFile::CIFFile | ( |  | ) |

Default constructor

## CIFFile() [2/2]

BALL::CIFFile::CIFFile | ( | const String & | filename,
|  | File::OpenMode | open_mode = std::ios::in )

Detailed constructor

Exceptions

  Exception::FileNotFound | if the file could not be opened

## ~CIFFile()

virtual BALL::CIFFile::~CIFFile | ( |  | ) |

virtual

Destructor

## Member Function Documentation

## clearParameters()

void BALL::CIFFile::clearParameters | ( |  | ) |

## getDatablock() [1/2]

Datablock & BALL::CIFFile::getDatablock | ( | const String & | name | ) |

## getDatablock() [2/2]

const Datablock & BALL::CIFFile::getDatablock | ( | const String & | name | ) | const

## hasDatablock()

bool BALL::CIFFile::hasDatablock | ( | const String & | name | ) | const

## inDatablock()

void BALL::CIFFile::inDatablock | ( | const char * | name | ) |

## inItem()

void BALL::CIFFile::inItem | ( | const char * | name | ) |

## initRead_()

virtual void BALL::CIFFile::initRead_ | ( |  | ) |

protected virtual

## inSafeframe()

void BALL::CIFFile::inSafeframe | ( | const char * | name | ) |

## insertDatablock()

void BALL::CIFFile::insertDatablock | ( | const Datablock & | datablock | ) |

## read()

virtual bool BALL::CIFFile::read | ( |  | ) |

virtual

Read a CIFFile.

Exceptions

  Exception::ParseError | if a syntax error was encountered

Reimplemented in BALL::NMRStarFile.

## setMolecule()

void BALL::CIFFile::setMolecule | ( | Molecule * | molecule | ) |

## write()

virtual bool BALL::CIFFile::write | ( |  | ) |

virtual

Write a CIFFile.

Exceptions

  File::CannotWrite | if writing to the file failed

## Member Data Documentation

## current_datablock_

String BALL::CIFFile::current_datablock_

protected

Definition at line 276 of file CIFFile.h.

## current_item_

String BALL::CIFFile::current_item_

protected

Definition at line 278 of file CIFFile.h.

## current_saveframe_

String BALL::CIFFile::current_saveframe_

protected

Definition at line 277 of file CIFFile.h.

## datablocks_

vector<Datablock> BALL::CIFFile::datablocks_

protected

Definition at line 281 of file CIFFile.h.

## datablocks_hash_

StringHashMap<Index> BALL::CIFFile::datablocks_hash_

protected

Definition at line 280 of file CIFFile.h.

## molecule_

Molecule* BALL::CIFFile::molecule_

protected

Definition at line 274 of file CIFFile.h.

## state

State BALL::CIFFile::state

static

Definition at line 269 of file CIFFile.h.